/* theme-extrusion.c generated by valac 0.56.17, the Vala compiler
 * generated from theme-extrusion.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2019 Arnaud Bonatti, with guidance from Jakub Steiner

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define EXTRUSION_THEME_radius_percent ((guint) 8)
#define EXTRUSION_THEME_HALF_PI G_PI_2
#define PUZZLE_VIEW_gap_factor 0.5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;

#define TYPE_EXTRUSION_THEME (extrusion_theme_get_type ())
#define EXTRUSION_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTRUSION_THEME, ExtrusionTheme))
#define EXTRUSION_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXTRUSION_THEME, ExtrusionThemeClass))
#define IS_EXTRUSION_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTRUSION_THEME))
#define IS_EXTRUSION_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXTRUSION_THEME))
#define EXTRUSION_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXTRUSION_THEME, ExtrusionThemeClass))

typedef struct _ExtrusionTheme ExtrusionTheme;
typedef struct _ExtrusionThemeClass ExtrusionThemeClass;
typedef struct _ExtrusionThemePrivate ExtrusionThemePrivate;
enum  {
	EXTRUSION_THEME_0_PROPERTY,
	EXTRUSION_THEME_NUM_PROPERTIES
};
static GParamSpec* extrusion_theme_properties[EXTRUSION_THEME_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
typedef struct _TilePrivate TilePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
	void (*configure) (Theme* self, guint size);
	void (*draw_arrow) (Theme* self, cairo_t* context);
	void (*draw_socket) (Theme* self, cairo_t* context);
	void (*draw_highlight) (Theme* self, cairo_t* context, gboolean has_tile);
	void (*draw_paused_tile) (Theme* self, cairo_t* context);
	void (*draw_tile) (Theme* self, cairo_t* context, Tile* tile, gboolean highlight);
	void (*set_animation_level) (Theme* self, guint8 animation_level);
};

struct _ExtrusionTheme {
	Theme parent_instance;
	ExtrusionThemePrivate * priv;
};

struct _ExtrusionThemeClass {
	ThemeClass parent_class;
};

struct _ExtrusionThemePrivate {
	cairo_pattern_t* tile_colors_h[10];
	cairo_pattern_t* tile_colors_v[10];
	cairo_pattern_t* tile_highlights_h[10];
	cairo_pattern_t* tile_highlights_v[10];
	cairo_pattern_t* tile_shadows[10];
	cairo_pattern_t* text_colors[10];
	cairo_pattern_t* black_text_color;
	cairo_pattern_t* white_text_color;
	cairo_pattern_t* paused_color_h;
	cairo_pattern_t* paused_color_v;
	guint size;
	guint8 animation_level;
	gdouble arrow_half_h;
	gdouble neg_arrow_half_h;
	gdouble arrow_w;
	gdouble arrow_x;
	gdouble arrow_clip_x;
	gdouble arrow_clip_y;
	gdouble arrow_clip_w;
	gdouble arrow_clip_h;
	gdouble arrow_opacity;
	cairo_pattern_t* highlight_tile_pattern;
	cairo_matrix_t matrix;
	guint tile_margin;
	gint tile_size;
	gdouble half_tile_size;
	gdouble extrusion;
	gdouble lateral_shadow_width;
	gdouble west_shadow_limit;
	gdouble north_shadow_limit;
	gdouble socket_opacity;
	gdouble font_size;
	gdouble half_tile_size_extruded;
	gdouble north_number_y_extruded;
	gdouble south_number_y_extruded;
	gdouble east_number_x;
	gdouble west_number_x;
};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	guint8 north;
	guint8 west;
	guint8 east;
	guint8 south;
};

struct _TileClass {
	GObjectClass parent_class;
};

static gint ExtrusionTheme_private_offset;
static gpointer extrusion_theme_parent_class = NULL;

VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
VALA_EXTERN GType extrusion_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExtrusionTheme, g_object_unref)
VALA_EXTERN void theme_configure (Theme* self,
                      guint size);
VALA_EXTERN void theme_set_animation_level (Theme* self,
                                guint8 animation_level);
VALA_EXTERN void theme_draw_arrow (Theme* self,
                       cairo_t* context);
VALA_EXTERN void theme_draw_socket (Theme* self,
                        cairo_t* context);
VALA_EXTERN void theme_draw_highlight (Theme* self,
                           cairo_t* context,
                           gboolean has_tile);
VALA_EXTERN void theme_draw_paused_tile (Theme* self,
                             cairo_t* context);
VALA_EXTERN void theme_draw_tile (Theme* self,
                      cairo_t* context,
                      Tile* tile,
                      gboolean highlight);
static void extrusion_theme_make_color_pattern (ExtrusionTheme* self,
                                         guint position,
                                         const gchar* color,
                                         gboolean white_text);
static cairo_pattern_t* extrusion_theme_make_dir_color_pattern (const gchar* color,
                                                         gboolean vertical,
                                                         gdouble color_factor);
static cairo_pattern_t* extrusion_theme_make_shadow_color_pattern (const gchar* color);
static gdouble extrusion_theme_hex_value (gchar c);
static void extrusion_theme_real_configure (Theme* base,
                                     guint new_size);
VALA_EXTERN void theme_set_overdraw_top (Theme* self,
                             gint value);
VALA_EXTERN gint theme_get_overdraw_top (Theme* self);
static void extrusion_theme_real_set_animation_level (Theme* base,
                                               guint8 new_animation_level);
static void extrusion_theme_real_draw_arrow (Theme* base,
                                      cairo_t* context);
static void extrusion_theme_real_draw_socket (Theme* base,
                                       cairo_t* context);
static void extrusion_theme_rounded_square (cairo_t* context,
                                     gdouble x,
                                     gdouble y,
                                     gint size,
                                     gdouble radius_percent);
static void extrusion_theme_real_draw_highlight (Theme* base,
                                          cairo_t* context,
                                          gboolean has_tile);
static void extrusion_theme_real_draw_paused_tile (Theme* base,
                                            cairo_t* context);
static void extrusion_theme_draw_tile_shadow (ExtrusionTheme* self,
                                       cairo_t* context,
                                       cairo_pattern_t* north_color,
                                       cairo_pattern_t* east_color,
                                       cairo_pattern_t* south_color,
                                       cairo_pattern_t* west_color);
static void extrusion_theme_draw_tile_background (ExtrusionTheme* self,
                                           cairo_t* context,
                                           cairo_pattern_t* north_color,
                                           cairo_pattern_t* east_color,
                                           cairo_pattern_t* south_color,
                                           cairo_pattern_t* west_color);
static void extrusion_theme_real_draw_tile (Theme* base,
                                     cairo_t* context,
                                     Tile* tile,
                                     gboolean highlight);
static void extrusion_theme_draw_number (cairo_t* context,
                                  cairo_pattern_t* text_color,
                                  gdouble x,
                                  gdouble y,
                                  guint8 number);
VALA_EXTERN ExtrusionTheme* extrusion_theme_new (void);
VALA_EXTERN ExtrusionTheme* extrusion_theme_construct (GType object_type);
VALA_EXTERN Theme* theme_construct (GType object_type);
static GObject * extrusion_theme_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void extrusion_theme_finalize (GObject * obj);
static GType extrusion_theme_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
extrusion_theme_get_instance_private (ExtrusionTheme* self)
{
	return G_STRUCT_MEMBER_P (self, ExtrusionTheme_private_offset);
}

static void
extrusion_theme_make_color_pattern (ExtrusionTheme* self,
                                    guint position,
                                    const gchar* color,
                                    gboolean white_text)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
#line 57 "../src/theme-extrusion.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/theme-extrusion.vala"
	g_return_if_fail (color != NULL);
#line 59 "../src/theme-extrusion.vala"
	_tmp0_ = extrusion_theme_make_dir_color_pattern (color, FALSE, 1.00);
#line 59 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors_h[position]);
#line 59 "../src/theme-extrusion.vala"
	self->priv->tile_colors_h[position] = _tmp0_;
#line 60 "../src/theme-extrusion.vala"
	_tmp1_ = extrusion_theme_make_dir_color_pattern (color, TRUE, 1.00);
#line 60 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors_v[position]);
#line 60 "../src/theme-extrusion.vala"
	self->priv->tile_colors_v[position] = _tmp1_;
#line 61 "../src/theme-extrusion.vala"
	_tmp2_ = extrusion_theme_make_dir_color_pattern (color, FALSE, 1.35);
#line 61 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->tile_highlights_h[position]);
#line 61 "../src/theme-extrusion.vala"
	self->priv->tile_highlights_h[position] = _tmp2_;
#line 62 "../src/theme-extrusion.vala"
	_tmp3_ = extrusion_theme_make_dir_color_pattern (color, TRUE, 1.35);
#line 62 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->tile_highlights_v[position]);
#line 62 "../src/theme-extrusion.vala"
	self->priv->tile_highlights_v[position] = _tmp3_;
#line 64 "../src/theme-extrusion.vala"
	_tmp4_ = extrusion_theme_make_shadow_color_pattern (color);
#line 64 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->tile_shadows[position]);
#line 64 "../src/theme-extrusion.vala"
	self->priv->tile_shadows[position] = _tmp4_;
#line 66 "../src/theme-extrusion.vala"
	if (white_text) {
#line 317 "theme-extrusion.c"
		cairo_pattern_t* _tmp5_;
#line 67 "../src/theme-extrusion.vala"
		_tmp5_ = self->priv->white_text_color;
#line 67 "../src/theme-extrusion.vala"
		self->priv->text_colors[position] = _tmp5_;
#line 323 "theme-extrusion.c"
	} else {
		cairo_pattern_t* _tmp6_;
#line 69 "../src/theme-extrusion.vala"
		_tmp6_ = self->priv->black_text_color;
#line 69 "../src/theme-extrusion.vala"
		self->priv->text_colors[position] = _tmp6_;
#line 330 "theme-extrusion.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 348 "theme-extrusion.c"
}

static cairo_pattern_t*
extrusion_theme_make_dir_color_pattern (const gchar* color,
                                        gboolean vertical,
                                        gdouble color_factor)
{
	gdouble r0 = 0.0;
	gdouble g0 = 0.0;
	gdouble b0 = 0.0;
	gdouble r1 = 0.0;
	gdouble g1 = 0.0;
	gdouble b1 = 0.0;
	cairo_pattern_t* pattern = NULL;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* result;
#line 72 "../src/theme-extrusion.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 74 "../src/theme-extrusion.vala"
	r0 = (((extrusion_theme_hex_value (string_get (color, (glong) 0)) * 16) + extrusion_theme_hex_value (string_get (color, (glong) 1))) / 255.0) * color_factor;
#line 75 "../src/theme-extrusion.vala"
	g0 = (((extrusion_theme_hex_value (string_get (color, (glong) 2)) * 16) + extrusion_theme_hex_value (string_get (color, (glong) 3))) / 255.0) * color_factor;
#line 76 "../src/theme-extrusion.vala"
	b0 = (((extrusion_theme_hex_value (string_get (color, (glong) 4)) * 16) + extrusion_theme_hex_value (string_get (color, (glong) 5))) / 255.0) * color_factor;
#line 78 "../src/theme-extrusion.vala"
	r1 = MIN (r0 + 0.01, 1.0);
#line 79 "../src/theme-extrusion.vala"
	g1 = MIN (g0 + 0.01, 1.0);
#line 80 "../src/theme-extrusion.vala"
	b1 = MIN (b0 + 0.01, 1.0);
#line 83 "../src/theme-extrusion.vala"
	if (vertical) {
#line 383 "theme-extrusion.c"
		cairo_pattern_t* _tmp0_;
#line 84 "../src/theme-extrusion.vala"
		_tmp0_ = cairo_pattern_create_linear (0.0, 0.0, 1.0, 0.0);
#line 84 "../src/theme-extrusion.vala"
		_cairo_pattern_destroy0 (pattern);
#line 84 "../src/theme-extrusion.vala"
		pattern = _tmp0_;
#line 391 "theme-extrusion.c"
	} else {
		cairo_pattern_t* _tmp1_;
#line 86 "../src/theme-extrusion.vala"
		_tmp1_ = cairo_pattern_create_linear (0.0, 0.0, 0.0, 1.0);
#line 86 "../src/theme-extrusion.vala"
		_cairo_pattern_destroy0 (pattern);
#line 86 "../src/theme-extrusion.vala"
		pattern = _tmp1_;
#line 400 "theme-extrusion.c"
	}
#line 87 "../src/theme-extrusion.vala"
	_tmp2_ = pattern;
#line 87 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp2_, 0.00, r0, g0, b0, 1.0);
#line 88 "../src/theme-extrusion.vala"
	_tmp3_ = pattern;
#line 88 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp3_, 0.50, r1, g1, b1, 1.0);
#line 89 "../src/theme-extrusion.vala"
	_tmp4_ = pattern;
#line 89 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp4_, 1.00, r0, g0, b0, 1.0);
#line 91 "../src/theme-extrusion.vala"
	result = pattern;
#line 91 "../src/theme-extrusion.vala"
	return result;
#line 418 "theme-extrusion.c"
}

static cairo_pattern_t*
extrusion_theme_make_shadow_color_pattern (const gchar* color)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* result;
#line 94 "../src/theme-extrusion.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 96 "../src/theme-extrusion.vala"
	r = ((extrusion_theme_hex_value (string_get (color, (glong) 0)) * 16) + extrusion_theme_hex_value (string_get (color, (glong) 1))) * 0.0032;
#line 97 "../src/theme-extrusion.vala"
	g = ((extrusion_theme_hex_value (string_get (color, (glong) 2)) * 16) + extrusion_theme_hex_value (string_get (color, (glong) 3))) * 0.0032;
#line 98 "../src/theme-extrusion.vala"
	b = ((extrusion_theme_hex_value (string_get (color, (glong) 4)) * 16) + extrusion_theme_hex_value (string_get (color, (glong) 5))) * 0.0032;
#line 100 "../src/theme-extrusion.vala"
	_tmp0_ = cairo_pattern_create_rgb (r, g, b);
#line 100 "../src/theme-extrusion.vala"
	result = _tmp0_;
#line 100 "../src/theme-extrusion.vala"
	return result;
#line 443 "theme-extrusion.c"
}

static gdouble
extrusion_theme_hex_value (gchar c)
{
	gboolean _tmp0_ = FALSE;
	gdouble result;
#line 105 "../src/theme-extrusion.vala"
	if (c >= '0') {
#line 105 "../src/theme-extrusion.vala"
		_tmp0_ = c <= '9';
#line 455 "theme-extrusion.c"
	} else {
#line 105 "../src/theme-extrusion.vala"
		_tmp0_ = FALSE;
#line 459 "theme-extrusion.c"
	}
#line 105 "../src/theme-extrusion.vala"
	if (_tmp0_) {
#line 106 "../src/theme-extrusion.vala"
		result = (gdouble) (c - '0');
#line 106 "../src/theme-extrusion.vala"
		return result;
#line 467 "theme-extrusion.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 107 "../src/theme-extrusion.vala"
		if (c >= 'a') {
#line 107 "../src/theme-extrusion.vala"
			_tmp1_ = c <= 'f';
#line 474 "theme-extrusion.c"
		} else {
#line 107 "../src/theme-extrusion.vala"
			_tmp1_ = FALSE;
#line 478 "theme-extrusion.c"
		}
#line 107 "../src/theme-extrusion.vala"
		if (_tmp1_) {
#line 108 "../src/theme-extrusion.vala"
			result = (gdouble) ((c - 'a') + 10);
#line 108 "../src/theme-extrusion.vala"
			return result;
#line 486 "theme-extrusion.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 109 "../src/theme-extrusion.vala"
			if (c >= 'A') {
#line 109 "../src/theme-extrusion.vala"
				_tmp2_ = c <= 'F';
#line 493 "theme-extrusion.c"
			} else {
#line 109 "../src/theme-extrusion.vala"
				_tmp2_ = FALSE;
#line 497 "theme-extrusion.c"
			}
#line 109 "../src/theme-extrusion.vala"
			if (_tmp2_) {
#line 110 "../src/theme-extrusion.vala"
				result = (gdouble) ((c - 'A') + 10);
#line 110 "../src/theme-extrusion.vala"
				return result;
#line 505 "theme-extrusion.c"
			} else {
#line 112 "../src/theme-extrusion.vala"
				result = 0.0;
#line 112 "../src/theme-extrusion.vala"
				return result;
#line 511 "theme-extrusion.c"
			}
		}
	}
}

static void
extrusion_theme_real_configure (Theme* base,
                                guint new_size)
{
	ExtrusionTheme * self;
	gboolean _tmp0_ = FALSE;
	gdouble highlight_radius = 0.0;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 160 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 162 "../src/theme-extrusion.vala"
	if (self->priv->size != ((guint) 0)) {
#line 162 "../src/theme-extrusion.vala"
		_tmp0_ = self->priv->size == new_size;
#line 539 "theme-extrusion.c"
	} else {
#line 162 "../src/theme-extrusion.vala"
		_tmp0_ = FALSE;
#line 543 "theme-extrusion.c"
	}
#line 162 "../src/theme-extrusion.vala"
	if (_tmp0_) {
#line 163 "../src/theme-extrusion.vala"
		return;
#line 549 "theme-extrusion.c"
	}
#line 166 "../src/theme-extrusion.vala"
	self->priv->arrow_w = (new_size * PUZZLE_VIEW_gap_factor) / 3.0;
#line 167 "../src/theme-extrusion.vala"
	self->priv->arrow_x = ((new_size * PUZZLE_VIEW_gap_factor) - self->priv->arrow_w) * 0.5;
#line 168 "../src/theme-extrusion.vala"
	self->priv->arrow_half_h = self->priv->arrow_w;
#line 169 "../src/theme-extrusion.vala"
	self->priv->neg_arrow_half_h = -self->priv->arrow_half_h;
#line 171 "../src/theme-extrusion.vala"
	self->priv->arrow_clip_x = -self->priv->arrow_x;
#line 172 "../src/theme-extrusion.vala"
	self->priv->arrow_clip_y = (gdouble) (-new_size);
#line 173 "../src/theme-extrusion.vala"
	self->priv->arrow_clip_w = (2.0 * self->priv->arrow_x) + self->priv->arrow_w;
#line 174 "../src/theme-extrusion.vala"
	self->priv->arrow_clip_h = 2.0 * new_size;
#line 177 "../src/theme-extrusion.vala"
	self->priv->half_tile_size = new_size * 0.5;
#line 178 "../src/theme-extrusion.vala"
	highlight_radius = new_size * 0.45;
#line 179 "../src/theme-extrusion.vala"
	_tmp1_ = cairo_pattern_create_radial (self->priv->half_tile_size, self->priv->half_tile_size, 0.0, self->priv->half_tile_size, self->priv->half_tile_size, highlight_radius);
#line 179 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->highlight_tile_pattern);
#line 179 "../src/theme-extrusion.vala"
	self->priv->highlight_tile_pattern = _tmp1_;
#line 181 "../src/theme-extrusion.vala"
	_tmp2_ = self->priv->highlight_tile_pattern;
#line 181 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp2_, 0.0, 1.0, 1.0, 1.0, 1.0);
#line 182 "../src/theme-extrusion.vala"
	_tmp3_ = self->priv->highlight_tile_pattern;
#line 182 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp3_, 0.2, 1.0, 1.0, 1.0, 0.8);
#line 183 "../src/theme-extrusion.vala"
	_tmp4_ = self->priv->highlight_tile_pattern;
#line 183 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp4_, 0.3, 1.0, 1.0, 1.0, 0.5);
#line 184 "../src/theme-extrusion.vala"
	_tmp5_ = self->priv->highlight_tile_pattern;
#line 184 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp5_, 0.4, 1.0, 1.0, 1.0, 0.2);
#line 185 "../src/theme-extrusion.vala"
	_tmp6_ = self->priv->highlight_tile_pattern;
#line 185 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp6_, 0.5, 1.0, 1.0, 1.0, 0.1);
#line 186 "../src/theme-extrusion.vala"
	_tmp7_ = self->priv->highlight_tile_pattern;
#line 186 "../src/theme-extrusion.vala"
	cairo_pattern_add_color_stop_rgba (_tmp7_, 1.0, 1.0, 1.0, 1.0, 0.0);
#line 189 "../src/theme-extrusion.vala"
	cairo_matrix_init_identity (&self->priv->matrix);
#line 190 "../src/theme-extrusion.vala"
	cairo_matrix_scale (&self->priv->matrix, 1.0 / new_size, 1.0 / new_size);
#line 191 "../src/theme-extrusion.vala"
	self->priv->tile_margin = MAX ((guint) (new_size * 0.03), (guint) 2);
#line 192 "../src/theme-extrusion.vala"
	self->priv->tile_size = ((gint) new_size) - (((gint) self->priv->tile_margin) * 2);
#line 193 "../src/theme-extrusion.vala"
	theme_set_overdraw_top ((Theme*) self, (gint) (1.5 * self->priv->tile_margin));
#line 194 "../src/theme-extrusion.vala"
	_tmp8_ = theme_get_overdraw_top ((Theme*) self);
#line 194 "../src/theme-extrusion.vala"
	_tmp9_ = _tmp8_;
#line 194 "../src/theme-extrusion.vala"
	self->priv->extrusion = (gdouble) (-_tmp9_);
#line 196 "../src/theme-extrusion.vala"
	self->priv->lateral_shadow_width = self->priv->tile_margin + (self->priv->tile_size * (G_SQRT2 / 50.0));
#line 197 "../src/theme-extrusion.vala"
	self->priv->west_shadow_limit = new_size - self->priv->lateral_shadow_width;
#line 198 "../src/theme-extrusion.vala"
	self->priv->north_shadow_limit = (self->priv->tile_margin + (self->priv->tile_size * (G_SQRT2 / 25.0))) + self->priv->extrusion;
#line 201 "../src/theme-extrusion.vala"
	self->priv->font_size = (new_size * 4.0) / 19.0;
#line 202 "../src/theme-extrusion.vala"
	self->priv->half_tile_size_extruded = self->priv->half_tile_size + self->priv->extrusion;
#line 203 "../src/theme-extrusion.vala"
	self->priv->north_number_y_extruded = ((new_size * 4.0) / 18.0) + self->priv->extrusion;
#line 204 "../src/theme-extrusion.vala"
	self->priv->south_number_y_extruded = ((new_size * 14.0) / 18.0) + self->priv->extrusion;
#line 205 "../src/theme-extrusion.vala"
	self->priv->east_number_x = (new_size * 15.0) / 19.0;
#line 206 "../src/theme-extrusion.vala"
	self->priv->west_number_x = (new_size * 4.0) / 19.0;
#line 209 "../src/theme-extrusion.vala"
	self->priv->size = new_size;
#line 637 "theme-extrusion.c"
}

static void
extrusion_theme_real_set_animation_level (Theme* base,
                                          guint8 new_animation_level)
{
	ExtrusionTheme * self;
#line 212 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 214 "../src/theme-extrusion.vala"
	self->priv->animation_level = new_animation_level;
#line 215 "../src/theme-extrusion.vala"
	self->priv->arrow_opacity = (0.4 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0;
#line 216 "../src/theme-extrusion.vala"
	self->priv->socket_opacity = (0.3 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0;
#line 653 "theme-extrusion.c"
}

static void
extrusion_theme_real_draw_arrow (Theme* base,
                                 cairo_t* context)
{
	ExtrusionTheme * self;
#line 223 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 223 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 225 "../src/theme-extrusion.vala"
	cairo_translate (context, self->priv->arrow_x, 0.0);
#line 227 "../src/theme-extrusion.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 228 "../src/theme-extrusion.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->arrow_half_h);
#line 229 "../src/theme-extrusion.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->neg_arrow_half_h);
#line 230 "../src/theme-extrusion.vala"
	cairo_close_path (context);
#line 231 "../src/theme-extrusion.vala"
	cairo_set_source_rgba (context, 0.5, 0.5, 0.5, self->priv->arrow_opacity);
#line 232 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 679 "theme-extrusion.c"
}

static void
extrusion_theme_real_draw_socket (Theme* base,
                                  cairo_t* context)
{
	ExtrusionTheme * self;
#line 239 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 239 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 241 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 243 "../src/theme-extrusion.vala"
	cairo_set_source_rgba (context, 0.5, 0.5, 0.5, self->priv->socket_opacity);
#line 244 "../src/theme-extrusion.vala"
	extrusion_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) EXTRUSION_THEME_radius_percent);
#line 248 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 250 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 701 "theme-extrusion.c"
}

static void
extrusion_theme_real_draw_highlight (Theme* base,
                                     cairo_t* context,
                                     gboolean has_tile)
{
	ExtrusionTheme * self;
	cairo_pattern_t* _tmp0_;
#line 257 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 257 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 259 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 261 "../src/theme-extrusion.vala"
	if (has_tile) {
#line 262 "../src/theme-extrusion.vala"
		cairo_translate (context, 0.0, self->priv->extrusion);
#line 721 "theme-extrusion.c"
	}
#line 264 "../src/theme-extrusion.vala"
	_tmp0_ = self->priv->highlight_tile_pattern;
#line 264 "../src/theme-extrusion.vala"
	cairo_set_source (context, _tmp0_);
#line 265 "../src/theme-extrusion.vala"
	cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 266 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 267 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 733 "theme-extrusion.c"
}

static void
extrusion_theme_real_draw_paused_tile (Theme* base,
                                       cairo_t* context)
{
	ExtrusionTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
#line 274 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 274 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 276 "../src/theme-extrusion.vala"
	_tmp0_ = self->priv->paused_color_h;
#line 276 "../src/theme-extrusion.vala"
	_tmp1_ = self->priv->paused_color_v;
#line 276 "../src/theme-extrusion.vala"
	_tmp2_ = self->priv->paused_color_h;
#line 276 "../src/theme-extrusion.vala"
	_tmp3_ = self->priv->paused_color_v;
#line 276 "../src/theme-extrusion.vala"
	extrusion_theme_draw_tile_shadow (self, context, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 277 "../src/theme-extrusion.vala"
	_tmp4_ = self->priv->paused_color_h;
#line 277 "../src/theme-extrusion.vala"
	_tmp5_ = self->priv->paused_color_v;
#line 277 "../src/theme-extrusion.vala"
	_tmp6_ = self->priv->paused_color_h;
#line 277 "../src/theme-extrusion.vala"
	_tmp7_ = self->priv->paused_color_v;
#line 277 "../src/theme-extrusion.vala"
	extrusion_theme_draw_tile_background (self, context, _tmp4_, _tmp5_, _tmp6_, _tmp7_);
#line 773 "theme-extrusion.c"
}

static void
extrusion_theme_real_draw_tile (Theme* base,
                                cairo_t* context,
                                Tile* tile,
                                gboolean highlight)
{
	ExtrusionTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_matrix_t _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_matrix_t _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_matrix_t _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_matrix_t _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_matrix_t _tmp11_;
	cairo_pattern_t* _tmp12_;
	cairo_matrix_t _tmp13_;
	cairo_pattern_t* _tmp14_;
	cairo_matrix_t _tmp15_;
	cairo_pattern_t* _tmp16_;
	cairo_pattern_t* _tmp17_;
	cairo_pattern_t* _tmp18_;
	cairo_pattern_t* _tmp19_;
	cairo_pattern_t* _tmp28_;
	cairo_pattern_t* _tmp29_;
	cairo_pattern_t* _tmp30_;
	cairo_pattern_t* _tmp31_;
#line 280 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) base;
#line 280 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 280 "../src/theme-extrusion.vala"
	g_return_if_fail (tile != NULL);
#line 282 "../src/theme-extrusion.vala"
	_tmp0_ = self->priv->tile_colors_h[tile->north];
#line 282 "../src/theme-extrusion.vala"
	_tmp1_ = self->priv->matrix;
#line 282 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp0_, &_tmp1_);
#line 283 "../src/theme-extrusion.vala"
	_tmp2_ = self->priv->tile_colors_h[tile->east];
#line 283 "../src/theme-extrusion.vala"
	_tmp3_ = self->priv->matrix;
#line 283 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp2_, &_tmp3_);
#line 284 "../src/theme-extrusion.vala"
	_tmp4_ = self->priv->tile_colors_h[tile->south];
#line 284 "../src/theme-extrusion.vala"
	_tmp5_ = self->priv->matrix;
#line 284 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp4_, &_tmp5_);
#line 285 "../src/theme-extrusion.vala"
	_tmp6_ = self->priv->tile_colors_h[tile->west];
#line 285 "../src/theme-extrusion.vala"
	_tmp7_ = self->priv->matrix;
#line 285 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp6_, &_tmp7_);
#line 286 "../src/theme-extrusion.vala"
	_tmp8_ = self->priv->tile_colors_v[tile->north];
#line 286 "../src/theme-extrusion.vala"
	_tmp9_ = self->priv->matrix;
#line 286 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp8_, &_tmp9_);
#line 287 "../src/theme-extrusion.vala"
	_tmp10_ = self->priv->tile_colors_v[tile->east];
#line 287 "../src/theme-extrusion.vala"
	_tmp11_ = self->priv->matrix;
#line 287 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp10_, &_tmp11_);
#line 288 "../src/theme-extrusion.vala"
	_tmp12_ = self->priv->tile_colors_v[tile->south];
#line 288 "../src/theme-extrusion.vala"
	_tmp13_ = self->priv->matrix;
#line 288 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp12_, &_tmp13_);
#line 289 "../src/theme-extrusion.vala"
	_tmp14_ = self->priv->tile_colors_v[tile->west];
#line 289 "../src/theme-extrusion.vala"
	_tmp15_ = self->priv->matrix;
#line 289 "../src/theme-extrusion.vala"
	cairo_pattern_set_matrix (_tmp14_, &_tmp15_);
#line 291 "../src/theme-extrusion.vala"
	_tmp16_ = self->priv->tile_shadows[tile->north];
#line 291 "../src/theme-extrusion.vala"
	_tmp17_ = self->priv->tile_shadows[tile->east];
#line 291 "../src/theme-extrusion.vala"
	_tmp18_ = self->priv->tile_shadows[tile->south];
#line 291 "../src/theme-extrusion.vala"
	_tmp19_ = self->priv->tile_shadows[tile->west];
#line 291 "../src/theme-extrusion.vala"
	extrusion_theme_draw_tile_shadow (self, context, _tmp16_, _tmp17_, _tmp18_, _tmp19_);
#line 292 "../src/theme-extrusion.vala"
	if (highlight) {
#line 873 "theme-extrusion.c"
		cairo_pattern_t* _tmp20_;
		cairo_pattern_t* _tmp21_;
		cairo_pattern_t* _tmp22_;
		cairo_pattern_t* _tmp23_;
#line 293 "../src/theme-extrusion.vala"
		_tmp20_ = self->priv->tile_highlights_h[tile->north];
#line 293 "../src/theme-extrusion.vala"
		_tmp21_ = self->priv->tile_highlights_v[tile->east];
#line 293 "../src/theme-extrusion.vala"
		_tmp22_ = self->priv->tile_highlights_h[tile->south];
#line 293 "../src/theme-extrusion.vala"
		_tmp23_ = self->priv->tile_highlights_v[tile->west];
#line 293 "../src/theme-extrusion.vala"
		extrusion_theme_draw_tile_background (self, context, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 888 "theme-extrusion.c"
	} else {
		cairo_pattern_t* _tmp24_;
		cairo_pattern_t* _tmp25_;
		cairo_pattern_t* _tmp26_;
		cairo_pattern_t* _tmp27_;
#line 295 "../src/theme-extrusion.vala"
		_tmp24_ = self->priv->tile_colors_h[tile->north];
#line 295 "../src/theme-extrusion.vala"
		_tmp25_ = self->priv->tile_colors_v[tile->east];
#line 295 "../src/theme-extrusion.vala"
		_tmp26_ = self->priv->tile_colors_h[tile->south];
#line 295 "../src/theme-extrusion.vala"
		_tmp27_ = self->priv->tile_colors_v[tile->west];
#line 295 "../src/theme-extrusion.vala"
		extrusion_theme_draw_tile_background (self, context, _tmp24_, _tmp25_, _tmp26_, _tmp27_);
#line 904 "theme-extrusion.c"
	}
#line 297 "../src/theme-extrusion.vala"
	cairo_select_font_face (context, "sans-serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 298 "../src/theme-extrusion.vala"
	cairo_set_font_size (context, self->priv->font_size);
#line 299 "../src/theme-extrusion.vala"
	_tmp28_ = self->priv->text_colors[tile->north];
#line 299 "../src/theme-extrusion.vala"
	extrusion_theme_draw_number (context, _tmp28_, self->priv->half_tile_size, self->priv->north_number_y_extruded, tile->north);
#line 300 "../src/theme-extrusion.vala"
	_tmp29_ = self->priv->text_colors[tile->south];
#line 300 "../src/theme-extrusion.vala"
	extrusion_theme_draw_number (context, _tmp29_, self->priv->half_tile_size, self->priv->south_number_y_extruded, tile->south);
#line 301 "../src/theme-extrusion.vala"
	_tmp30_ = self->priv->text_colors[tile->east];
#line 301 "../src/theme-extrusion.vala"
	extrusion_theme_draw_number (context, _tmp30_, self->priv->east_number_x, self->priv->half_tile_size_extruded, tile->east);
#line 302 "../src/theme-extrusion.vala"
	_tmp31_ = self->priv->text_colors[tile->west];
#line 302 "../src/theme-extrusion.vala"
	extrusion_theme_draw_number (context, _tmp31_, self->priv->west_number_x, self->priv->half_tile_size_extruded, tile->west);
#line 926 "theme-extrusion.c"
}

static void
extrusion_theme_draw_tile_shadow (ExtrusionTheme* self,
                                  cairo_t* context,
                                  cairo_pattern_t* north_color,
                                  cairo_pattern_t* east_color,
                                  cairo_pattern_t* south_color,
                                  cairo_pattern_t* west_color)
{
#line 305 "../src/theme-extrusion.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 305 "../src/theme-extrusion.vala"
	g_return_if_fail (north_color != NULL);
#line 305 "../src/theme-extrusion.vala"
	g_return_if_fail (east_color != NULL);
#line 305 "../src/theme-extrusion.vala"
	g_return_if_fail (south_color != NULL);
#line 305 "../src/theme-extrusion.vala"
	g_return_if_fail (west_color != NULL);
#line 307 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 310 "../src/theme-extrusion.vala"
	extrusion_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) EXTRUSION_THEME_radius_percent);
#line 314 "../src/theme-extrusion.vala"
	cairo_clip (context);
#line 316 "../src/theme-extrusion.vala"
	cairo_rectangle (context, 0.0, self->priv->north_shadow_limit, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 317 "../src/theme-extrusion.vala"
	cairo_clip (context);
#line 320 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 322 "../src/theme-extrusion.vala"
	cairo_rectangle (context, 0.0, self->priv->half_tile_size, (gdouble) self->priv->size, self->priv->half_tile_size);
#line 324 "../src/theme-extrusion.vala"
	cairo_set_source (context, south_color);
#line 325 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 327 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 330 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 332 "../src/theme-extrusion.vala"
	cairo_rectangle (context, self->priv->west_shadow_limit, 0.0, self->priv->lateral_shadow_width, (gdouble) self->priv->size);
#line 334 "../src/theme-extrusion.vala"
	cairo_set_source (context, east_color);
#line 335 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 337 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 340 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 342 "../src/theme-extrusion.vala"
	cairo_rectangle (context, 0.0, 0.0, self->priv->lateral_shadow_width, (gdouble) self->priv->size);
#line 344 "../src/theme-extrusion.vala"
	cairo_set_source (context, west_color);
#line 345 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 347 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 350 "../src/theme-extrusion.vala"
	cairo_reset_clip (context);
#line 351 "../src/theme-extrusion.vala"
	extrusion_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) EXTRUSION_THEME_radius_percent);
#line 356 "../src/theme-extrusion.vala"
	cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.2);
#line 357 "../src/theme-extrusion.vala"
	cairo_set_line_width (context, 0.75);
#line 358 "../src/theme-extrusion.vala"
	cairo_stroke_preserve (context);
#line 359 "../src/theme-extrusion.vala"
	cairo_clip (context);
#line 361 "../src/theme-extrusion.vala"
	cairo_move_to (context, self->priv->lateral_shadow_width, 0.0);
#line 362 "../src/theme-extrusion.vala"
	cairo_line_to (context, self->priv->lateral_shadow_width, (gdouble) self->priv->size);
#line 363 "../src/theme-extrusion.vala"
	cairo_move_to (context, self->priv->west_shadow_limit, 0.0);
#line 364 "../src/theme-extrusion.vala"
	cairo_line_to (context, self->priv->west_shadow_limit, (gdouble) self->priv->size);
#line 365 "../src/theme-extrusion.vala"
	cairo_set_source_rgba (context, 0.4, 0.4, 0.4, 0.4);
#line 366 "../src/theme-extrusion.vala"
	cairo_set_line_width (context, 1.0);
#line 367 "../src/theme-extrusion.vala"
	cairo_stroke (context);
#line 369 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 1017 "theme-extrusion.c"
}

static void
extrusion_theme_draw_tile_background (ExtrusionTheme* self,
                                      cairo_t* context,
                                      cairo_pattern_t* north_color,
                                      cairo_pattern_t* east_color,
                                      cairo_pattern_t* south_color,
                                      cairo_pattern_t* west_color)
{
#line 372 "../src/theme-extrusion.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 372 "../src/theme-extrusion.vala"
	g_return_if_fail (north_color != NULL);
#line 372 "../src/theme-extrusion.vala"
	g_return_if_fail (east_color != NULL);
#line 372 "../src/theme-extrusion.vala"
	g_return_if_fail (south_color != NULL);
#line 372 "../src/theme-extrusion.vala"
	g_return_if_fail (west_color != NULL);
#line 375 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 377 "../src/theme-extrusion.vala"
	cairo_translate (context, 0.0, self->priv->extrusion);
#line 380 "../src/theme-extrusion.vala"
	extrusion_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) EXTRUSION_THEME_radius_percent);
#line 384 "../src/theme-extrusion.vala"
	cairo_clip_preserve (context);
#line 387 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 391 "../src/theme-extrusion.vala"
	cairo_set_source (context, north_color);
#line 392 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 394 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 397 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 399 "../src/theme-extrusion.vala"
	cairo_rectangle (context, 0.0, self->priv->half_tile_size, (gdouble) self->priv->size, self->priv->half_tile_size);
#line 401 "../src/theme-extrusion.vala"
	cairo_set_source (context, south_color);
#line 402 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 404 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 407 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 409 "../src/theme-extrusion.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 410 "../src/theme-extrusion.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 411 "../src/theme-extrusion.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 412 "../src/theme-extrusion.vala"
	cairo_close_path (context);
#line 414 "../src/theme-extrusion.vala"
	cairo_set_source (context, east_color);
#line 415 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 417 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 420 "../src/theme-extrusion.vala"
	cairo_save (context);
#line 422 "../src/theme-extrusion.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 423 "../src/theme-extrusion.vala"
	cairo_line_to (context, 0.0, (gdouble) self->priv->size);
#line 424 "../src/theme-extrusion.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 425 "../src/theme-extrusion.vala"
	cairo_close_path (context);
#line 427 "../src/theme-extrusion.vala"
	cairo_set_source (context, west_color);
#line 428 "../src/theme-extrusion.vala"
	cairo_fill (context);
#line 430 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 434 "../src/theme-extrusion.vala"
	cairo_reset_clip (context);
#line 435 "../src/theme-extrusion.vala"
	extrusion_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) EXTRUSION_THEME_radius_percent);
#line 440 "../src/theme-extrusion.vala"
	cairo_set_source_rgba (context, 0.0, 0.0, 0.0, 0.2);
#line 441 "../src/theme-extrusion.vala"
	cairo_set_line_width (context, 0.75);
#line 442 "../src/theme-extrusion.vala"
	cairo_stroke_preserve (context);
#line 443 "../src/theme-extrusion.vala"
	cairo_clip (context);
#line 445 "../src/theme-extrusion.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 446 "../src/theme-extrusion.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 447 "../src/theme-extrusion.vala"
	cairo_move_to (context, 0.0, (gdouble) self->priv->size);
#line 448 "../src/theme-extrusion.vala"
	cairo_line_to (context, (gdouble) self->priv->size, 0.0);
#line 449 "../src/theme-extrusion.vala"
	cairo_set_source_rgba (context, 0.4, 0.4, 0.4, 0.4);
#line 450 "../src/theme-extrusion.vala"
	cairo_set_line_width (context, 1.0);
#line 451 "../src/theme-extrusion.vala"
	cairo_stroke (context);
#line 453 "../src/theme-extrusion.vala"
	cairo_restore (context);
#line 1126 "theme-extrusion.c"
}

static void
extrusion_theme_draw_number (cairo_t* context,
                             cairo_pattern_t* text_color,
                             gdouble x,
                             gdouble y,
                             guint8 number)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
#line 456 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 456 "../src/theme-extrusion.vala"
	g_return_if_fail (text_color != NULL);
#line 458 "../src/theme-extrusion.vala"
	cairo_set_source (context, text_color);
#line 460 "../src/theme-extrusion.vala"
	_tmp0_ = g_strdup_printf ("%hu", (gushort) number);
#line 460 "../src/theme-extrusion.vala"
	text = _tmp0_;
#line 462 "../src/theme-extrusion.vala"
	cairo_text_extents (context, text, &_tmp1_);
#line 462 "../src/theme-extrusion.vala"
	extents = _tmp1_;
#line 463 "../src/theme-extrusion.vala"
	_tmp2_ = extents;
#line 463 "../src/theme-extrusion.vala"
	_tmp3_ = extents;
#line 463 "../src/theme-extrusion.vala"
	cairo_move_to (context, x - (_tmp2_.width / 2.0), y + (_tmp3_.height / 2.0));
#line 464 "../src/theme-extrusion.vala"
	cairo_show_text (context, text);
#line 456 "../src/theme-extrusion.vala"
	_g_free0 (text);
#line 1166 "theme-extrusion.c"
}

static void
extrusion_theme_rounded_square (cairo_t* context,
                                gdouble x,
                                gdouble y,
                                gint size,
                                gdouble radius_percent)
{
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 472 "../src/theme-extrusion.vala"
	g_return_if_fail (context != NULL);
#line 474 "../src/theme-extrusion.vala"
	if (radius_percent <= 0.0) {
#line 475 "../src/theme-extrusion.vala"
		g_assert_not_reached ();
#line 1187 "theme-extrusion.c"
	}
#line 477 "../src/theme-extrusion.vala"
	if (radius_percent > 50.0) {
#line 478 "../src/theme-extrusion.vala"
		radius_percent = 50.0;
#line 1193 "theme-extrusion.c"
	}
#line 479 "../src/theme-extrusion.vala"
	radius_arc = (radius_percent * size) / 100.0;
#line 480 "../src/theme-extrusion.vala"
	x1 = x + radius_arc;
#line 481 "../src/theme-extrusion.vala"
	y1 = y + radius_arc;
#line 482 "../src/theme-extrusion.vala"
	x2 = (x + size) - radius_arc;
#line 483 "../src/theme-extrusion.vala"
	y2 = (y + size) - radius_arc;
#line 485 "../src/theme-extrusion.vala"
	cairo_move_to (context, x, y1);
#line 486 "../src/theme-extrusion.vala"
	cairo_arc (context, x1, y1, radius_arc, G_PI, -EXTRUSION_THEME_HALF_PI);
#line 487 "../src/theme-extrusion.vala"
	cairo_arc (context, x2, y1, radius_arc, -EXTRUSION_THEME_HALF_PI, 0.0);
#line 488 "../src/theme-extrusion.vala"
	cairo_arc (context, x2, y2, radius_arc, 0.0, EXTRUSION_THEME_HALF_PI);
#line 489 "../src/theme-extrusion.vala"
	cairo_arc (context, x1, y2, radius_arc, EXTRUSION_THEME_HALF_PI, G_PI);
#line 490 "../src/theme-extrusion.vala"
	cairo_close_path (context);
#line 1217 "theme-extrusion.c"
}

ExtrusionTheme*
extrusion_theme_construct (GType object_type)
{
	ExtrusionTheme * self = NULL;
#line 21 "../src/theme-extrusion.vala"
	self = (ExtrusionTheme*) theme_construct (object_type);
#line 21 "../src/theme-extrusion.vala"
	return self;
#line 1228 "theme-extrusion.c"
}

ExtrusionTheme*
extrusion_theme_new (void)
{
#line 21 "../src/theme-extrusion.vala"
	return extrusion_theme_construct (TYPE_EXTRUSION_THEME);
#line 1236 "theme-extrusion.c"
}

static GObject *
extrusion_theme_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ExtrusionTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
#line 40 "../src/theme-extrusion.vala"
	parent_class = G_OBJECT_CLASS (extrusion_theme_parent_class);
#line 40 "../src/theme-extrusion.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/theme-extrusion.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTRUSION_THEME, ExtrusionTheme);
#line 42 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 0, "3d3846", TRUE);
#line 43 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 1, "C01C28", TRUE);
#line 44 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 2, "FFA348", FALSE);
#line 45 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 3, "f6d32d", FALSE);
#line 46 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 4, "57E389", FALSE);
#line 47 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 5, "B5835A", TRUE);
#line 48 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 6, "99c1f1", FALSE);
#line 49 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 7, "1a5fb4", TRUE);
#line 50 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 8, "c061cb", TRUE);
#line 51 "../src/theme-extrusion.vala"
	extrusion_theme_make_color_pattern (self, (guint) 9, "f6f5f4", FALSE);
#line 53 "../src/theme-extrusion.vala"
	_tmp0_ = extrusion_theme_make_dir_color_pattern ("CCCCCC", FALSE, 1.0);
#line 53 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_h);
#line 53 "../src/theme-extrusion.vala"
	self->priv->paused_color_h = _tmp0_;
#line 54 "../src/theme-extrusion.vala"
	_tmp1_ = extrusion_theme_make_dir_color_pattern ("CCCCCC", TRUE, 1.0);
#line 54 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_v);
#line 54 "../src/theme-extrusion.vala"
	self->priv->paused_color_v = _tmp1_;
#line 40 "../src/theme-extrusion.vala"
	return obj;
#line 1289 "theme-extrusion.c"
}

static void
extrusion_theme_class_init (ExtrusionThemeClass * klass,
                            gpointer klass_data)
{
#line 21 "../src/theme-extrusion.vala"
	extrusion_theme_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/theme-extrusion.vala"
	g_type_class_adjust_private_offset (klass, &ExtrusionTheme_private_offset);
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->configure = (void (*) (Theme*, guint)) extrusion_theme_real_configure;
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->set_animation_level = (void (*) (Theme*, guint8)) extrusion_theme_real_set_animation_level;
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->draw_arrow = (void (*) (Theme*, cairo_t*)) extrusion_theme_real_draw_arrow;
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->draw_socket = (void (*) (Theme*, cairo_t*)) extrusion_theme_real_draw_socket;
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->draw_highlight = (void (*) (Theme*, cairo_t*, gboolean)) extrusion_theme_real_draw_highlight;
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->draw_paused_tile = (void (*) (Theme*, cairo_t*)) extrusion_theme_real_draw_paused_tile;
#line 21 "../src/theme-extrusion.vala"
	((ThemeClass *) klass)->draw_tile = (void (*) (Theme*, cairo_t*, Tile*, gboolean)) extrusion_theme_real_draw_tile;
#line 21 "../src/theme-extrusion.vala"
	G_OBJECT_CLASS (klass)->constructor = extrusion_theme_constructor;
#line 21 "../src/theme-extrusion.vala"
	G_OBJECT_CLASS (klass)->finalize = extrusion_theme_finalize;
#line 1318 "theme-extrusion.c"
}

static void
extrusion_theme_instance_init (ExtrusionTheme * self,
                               gpointer klass)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
#line 21 "../src/theme-extrusion.vala"
	self->priv = extrusion_theme_get_instance_private (self);
#line 34 "../src/theme-extrusion.vala"
	_tmp0_ = cairo_pattern_create_rgb (0.0, 0.0, 0.0);
#line 34 "../src/theme-extrusion.vala"
	self->priv->black_text_color = _tmp0_;
#line 35 "../src/theme-extrusion.vala"
	_tmp1_ = cairo_pattern_create_rgb (1.0, 1.0, 1.0);
#line 35 "../src/theme-extrusion.vala"
	self->priv->white_text_color = _tmp1_;
#line 119 "../src/theme-extrusion.vala"
	self->priv->size = (guint) 0;
#line 120 "../src/theme-extrusion.vala"
	self->priv->animation_level = (guint8) 0;
#line 1341 "theme-extrusion.c"
}

static void
extrusion_theme_finalize (GObject * obj)
{
	ExtrusionTheme * self;
#line 21 "../src/theme-extrusion.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTRUSION_THEME, ExtrusionTheme);
#line 27 "../src/theme-extrusion.vala"
	_vala_array_destroy (self->priv->tile_colors_h, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 28 "../src/theme-extrusion.vala"
	_vala_array_destroy (self->priv->tile_colors_v, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 29 "../src/theme-extrusion.vala"
	_vala_array_destroy (self->priv->tile_highlights_h, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 30 "../src/theme-extrusion.vala"
	_vala_array_destroy (self->priv->tile_highlights_v, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 31 "../src/theme-extrusion.vala"
	_vala_array_destroy (self->priv->tile_shadows, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 34 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->black_text_color);
#line 35 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->white_text_color);
#line 37 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_h);
#line 38 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_v);
#line 136 "../src/theme-extrusion.vala"
	_cairo_pattern_destroy0 (self->priv->highlight_tile_pattern);
#line 21 "../src/theme-extrusion.vala"
	G_OBJECT_CLASS (extrusion_theme_parent_class)->finalize (obj);
#line 1372 "theme-extrusion.c"
}

static GType
extrusion_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExtrusionThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) extrusion_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExtrusionTheme), 0, (GInstanceInitFunc) extrusion_theme_instance_init, NULL };
	GType extrusion_theme_type_id;
	extrusion_theme_type_id = g_type_register_static (TYPE_THEME, "ExtrusionTheme", &g_define_type_info, 0);
	ExtrusionTheme_private_offset = g_type_add_instance_private (extrusion_theme_type_id, sizeof (ExtrusionThemePrivate));
	return extrusion_theme_type_id;
}

GType
extrusion_theme_get_type (void)
{
	static volatile gsize extrusion_theme_type_id__once = 0;
	if (g_once_init_enter (&extrusion_theme_type_id__once)) {
		GType extrusion_theme_type_id;
		extrusion_theme_type_id = extrusion_theme_get_type_once ();
		g_once_init_leave (&extrusion_theme_type_id__once, extrusion_theme_type_id);
	}
	return extrusion_theme_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

